"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonResultsAdapterFactory = void 0;
var breeze_client_1 = require("breeze-client");
var JsonResultsAdapterFactory = (function () {
    function JsonResultsAdapterFactory() {
    }
    JsonResultsAdapterFactory.create = function () {
        var adapter = new breeze_client_1.JsonResultsAdapter({
            name: 'OData4',
            visitNode: JsonResultsAdapterFactory.visitNode
        });
        return adapter;
    };
    JsonResultsAdapterFactory.visitNode = function (node, mappingContext, nodeContext) {
        var result = {};
        var metadataStore = mappingContext.entityManager.metadataStore;
        var workingNode = node;
        var nodeODataType;
        if (node === null) {
            return result;
        }
        var entityType;
        var entityTypeName;
        if (nodeContext.nodeType === 'root') {
            if (mappingContext.query instanceof breeze_client_1.EntityQuery) {
                var eq = mappingContext.query;
                if (eq.resultEntityType) {
                    entityType = eq.resultEntityType;
                }
                else {
                    entityTypeName = metadataStore.getEntityTypeNameForResourceName(eq.resourceName);
                }
            }
            else {
                nodeODataType = node['@odata.type'];
                entityTypeName = breeze_client_1.MetadataStore.normalizeTypeName(nodeODataType.replace('#', ''));
            }
        }
        else if (nodeContext.nodeType === 'navProp' || nodeContext.nodeType === 'navPropItem') {
            entityTypeName = nodeContext.navigationProperty.entityTypeName;
        }
        entityType = entityType || (entityTypeName && metadataStore.getEntityType(entityTypeName, true));
        if (entityType) {
            result.entityType = entityType;
            result.extraMetadata = {};
        }
        if (node.results) {
            result['node'] = node.results;
        }
        var propertyName = nodeContext.propertyName;
        result.ignore =
            workingNode.__deferred != null ||
                propertyName === '__metadata' ||
                (propertyName === 'EntityKey' && workingNode.$type && breeze_client_1.core.stringStartsWith(workingNode.$type, 'System.Data'));
        return result;
    };
    return JsonResultsAdapterFactory;
}());
exports.JsonResultsAdapterFactory = JsonResultsAdapterFactory;
//# sourceMappingURL=breeze-jsonResultsAdapter-factory.js.map