"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OData4DataService = exports.ProxyDataService = void 0;
var breeze_client_1 = require("breeze-client");
var ts_odatajs_1 = require("ts-odatajs");
var breeze_jsonResultsAdapter_factory_1 = require("./breeze-jsonResultsAdapter-factory");
var odata_error_1 = require("./odata-error");
var utilities_1 = require("./utilities");
var ProxyDataService = (function () {
    function ProxyDataService() {
    }
    return ProxyDataService;
}());
exports.ProxyDataService = ProxyDataService;
Object.setPrototypeOf(ProxyDataService, breeze_client_1.config.getAdapter('dataService', 'webApi'));
var OData4DataService = (function (_super) {
    __extends(OData4DataService, _super);
    function OData4DataService() {
        var _this = _super.call(this) || this;
        _this.innerAdapter = breeze_client_1.config.getAdapterInstance('dataService', 'webApi');
        _this.actions = [];
        _this.name = OData4DataService.BreezeAdapterName;
        _this.headers = {
            'OData-Version': '4.0'
        };
        _this.metadataAcceptHeader = 'application/json;odata.metadata=full';
        return _this;
    }
    OData4DataService.register = function () {
        breeze_client_1.config.registerAdapter('dataService', OData4DataService);
    };
    Object.defineProperty(OData4DataService.prototype, "changeRequestInterceptor", {
        get: function () {
            return this.innerAdapter.changeRequestInterceptor;
        },
        enumerable: false,
        configurable: true
    });
    OData4DataService.prototype._catchNoConnectionError = function (err) {
        return this.innerAdapter._catchNoConnectionError(err);
    };
    OData4DataService.prototype._createChangeRequestInterceptor = function (saveContext, saveBundle) {
        return this.innerAdapter._createChangeRequestInterceptor(saveContext, saveBundle);
    };
    OData4DataService.prototype.checkForRecomposition = function (interfaceInitializedArgs) {
        this.innerAdapter.checkForRecomposition(interfaceInitializedArgs);
    };
    OData4DataService.prototype._prepareSaveBundle = function (saveContext, saveBundle) {
        return this.innerAdapter._prepareSaveBundle(saveContext, saveBundle);
    };
    OData4DataService.prototype._prepareSaveResult = function (saveContext, saveResult) {
        return this.innerAdapter._prepareSaveResult(saveContext, saveResult);
    };
    OData4DataService.prototype.initialize = function () {
        this.jsonResultsAdapter = breeze_jsonResultsAdapter_factory_1.JsonResultsAdapterFactory.create();
    };
    OData4DataService.prototype.getAbsoluteUrl = function (dataService, url) {
        var serviceName = dataService.qualifyUrl('');
        var base = breeze_client_1.core.stringStartsWith(url, serviceName) ? '' : serviceName;
        if (typeof window !== 'undefined' && !serviceName.startsWith('//') && !serviceName.startsWith('http')) {
            base = "".concat(location.origin).concat(breeze_client_1.core.stringStartsWith(serviceName, '/') ? '' : '/').concat(base);
        }
        return base + url;
    };
    OData4DataService.prototype.fetchMetadata = function (metadataStore, dataService) {
        var _this = this;
        var serviceName = dataService.serviceName;
        var url = this.getAbsoluteUrl(dataService, '$metadata');
        return new Promise(function (resolve, reject) {
            ts_odatajs_1.oData.read({
                requestUri: url,
                headers: __assign(__assign({}, _this.headers), { Accept: _this.metadataAcceptHeader })
            }, function (data) {
                if (!(data === null || data === void 0 ? void 0 : data.dataServices)) {
                    var error = new Error("Metadata query failed for: ".concat(url));
                    return reject(error);
                }
                _this.metadata = data;
                var csdlMetadata = _this.metadata.dataServices;
                utilities_1.Utilities.adaptMetadata(_this.metadata);
                if (!metadataStore.hasMetadataFor(serviceName)) {
                    try {
                        metadataStore.importMetadata(csdlMetadata);
                    }
                    catch (e) {
                        reject(new Error("Metadata query failed for ".concat(url, "; Unable to process returned metadata: ").concat(e.message)));
                    }
                    metadataStore.addDataService(dataService);
                }
                _this.actions = utilities_1.Utilities.getActions(_this.metadata, metadataStore);
                resolve(csdlMetadata);
            }, function (error) {
                var err = _this.createError(error, url);
                err.message = "Metadata query failed for: ".concat(url, "; ").concat(err.message);
                reject(err);
            }, ts_odatajs_1.oData.metadataHandler, _this.httpClient);
        });
    };
    OData4DataService.prototype.executeQuery = function (mappingContext) {
        var _this = this;
        var query = mappingContext.query;
        var request = this.getRequest(mappingContext);
        return new Promise(function (resolve, reject) {
            ts_odatajs_1.oData.request(request, function (data, response) {
                var inlineCount;
                var results;
                if (data) {
                    inlineCount = Number(data['@odata.count']);
                    results = data.value;
                }
                resolve({ results: results, query: query, inlineCount: inlineCount, httpResponse: response });
            }, function (error) {
                var err = _this.createError(error, request.requestUri);
                reject(err);
            }, null, _this.httpClient);
        });
    };
    OData4DataService.prototype.saveChanges = function (saveContext, saveBundle) {
        var _this = this;
        saveContext.adapter = this;
        saveContext.routePrefix = this.getAbsoluteUrl(saveContext.dataService, '');
        var url = "".concat(saveContext.routePrefix, "$batch");
        var requestData = this.createChangeRequests(saveContext, saveBundle);
        var tempKeys = saveContext.tempKeys;
        var contentKeys = saveContext.contentKeys;
        return new Promise(function (resolve, reject) {
            ts_odatajs_1.oData.request({
                method: 'POST',
                requestUri: url,
                headers: __assign({}, _this.headers),
                data: requestData
            }, function (data) {
                var entities = [];
                var keyMappings = [];
                var saveResult = { entities: entities, keyMappings: keyMappings, deletedKeys: null };
                data.__batchResponses.forEach(function (br) {
                    br.__changeResponses.forEach(function (cr, index) {
                        var _a;
                        var chResponse = cr.response || cr;
                        var statusCode = chResponse.statusCode;
                        if (!statusCode || Number(statusCode) >= 400) {
                            var err = _this.createError(cr, url);
                            reject(err);
                            return;
                        }
                        var contentId = Number((_a = (chResponse.headers || {})['Content-ID']) !== null && _a !== void 0 ? _a : 0);
                        var origEntity = contentKeys[contentId];
                        var rawEntity = chResponse.data;
                        if (rawEntity) {
                            var tempKey = tempKeys[contentId];
                            if (tempKey) {
                                var entityType = tempKey.entityType;
                                if (entityType.autoGeneratedKeyType !== breeze_client_1.AutoGeneratedKeyType.None) {
                                    var tempValue = tempKey.values[0];
                                    var realKey = entityType.getEntityKeyFromRawEntity(rawEntity, breeze_client_1.DataProperty.getRawValueFromServer);
                                    var keyMapping = {
                                        entityTypeName: entityType.name,
                                        tempValue: tempValue,
                                        realValue: realKey.values[0]
                                    };
                                    keyMappings.push(keyMapping);
                                }
                            }
                            entities.push(rawEntity);
                        }
                        else if (origEntity) {
                            entities.push(origEntity);
                        }
                    });
                });
                resolve(saveResult);
            }, function (err) {
                var error = _this.createError(err, url);
                reject(error);
            }, ts_odatajs_1.oData.batch.batchHandler, _this.httpClient, _this.metadata);
        });
    };
    OData4DataService.prototype.createChangeRequests = function (saveContext, saveBundle) {
        var _this = this;
        var changeRequestInterceptor = this._createChangeRequestInterceptor(saveContext, saveBundle);
        var changeRequests = [];
        var tempKeys = [];
        var contentKeys = [];
        var entityManager = saveContext.entityManager;
        var helper = entityManager.helper;
        var contentId = 1;
        var routePrefix = saveContext.routePrefix;
        saveBundle.entities.forEach(function (entity, index) {
            var aspect = entity.entityAspect;
            var request = {
                headers: __assign({ 'Content-ID': contentId.toString(), 'Content-Type': 'application/json;IEEE754Compatible=true' }, _this.headers),
                requestUri: null,
                method: null
            };
            contentKeys[contentId] = entity;
            if (aspect.entityState.isAdded()) {
                request.requestUri = routePrefix + entity.entityType.defaultResourceName;
                request.method = 'POST';
                request.data = helper.unwrapInstance(entity, _this.transformValue);
                tempKeys[contentId] = aspect.getKey();
            }
            else if (aspect.entityState.isModified()) {
                _this.updateDeleteMergeRequest(request, aspect, routePrefix);
                request.method = 'PATCH';
                request.data = helper.unwrapChangedValues(entity, entityManager.metadataStore, _this.transformValue);
            }
            else if (aspect.entityState.isDeleted()) {
                _this.updateDeleteMergeRequest(request, aspect, routePrefix);
                request.method = 'DELETE';
            }
            else {
                return;
            }
            request = changeRequestInterceptor.getRequest(request, entity, index);
            changeRequests.push(request);
            contentId++;
        });
        saveContext.contentKeys = contentKeys;
        saveContext.tempKeys = tempKeys;
        changeRequestInterceptor.done(changeRequests);
        var changeRequestSet = [
            {
                __changeRequests: changeRequests
            }
        ];
        var batchRequest = {
            __batchRequests: changeRequestSet
        };
        return batchRequest;
    };
    OData4DataService.prototype.getRequest = function (mappingContext) {
        var _a;
        var query = mappingContext.query;
        var method = 'GET';
        var request = {
            method: method,
            requestUri: this.getUrl(mappingContext),
            headers: __assign({}, this.headers)
        };
        if (!(query === null || query === void 0 ? void 0 : query.parameters)) {
            return request;
        }
        method = query.parameters['$method'] || method;
        delete query.parameters['$method'];
        if (method === 'GET') {
            request = __assign(__assign({}, request), { requestUri: this.addQueryString(request.requestUri, query.parameters) });
        }
        else {
            var data = (_a = this.getData(mappingContext, query.parameters['$data'])) !== null && _a !== void 0 ? _a : query.parameters;
            request = __assign(__assign({}, request), { method: method, data: data });
        }
        return request;
    };
    OData4DataService.prototype.getData = function (mappingContext, data) {
        if (!data) {
            return null;
        }
        if (!this.areValidPropertyNames(mappingContext.metadataStore, data)) {
            return data;
        }
        var helper = mappingContext.entityManager.helper;
        if (data.entityType || data.complexType) {
            return helper.unwrapInstance(data, null);
        }
        var invokeConfig = this.getInvokableConfig(mappingContext.query.resourceName);
        var actionEntry = this.actions.find(function (e) { return e.config === invokeConfig; });
        if (!actionEntry) {
            return data;
        }
        var paramStartIndex = Number((invokeConfig.isBound === 'true'));
        var param = invokeConfig.parameter.find(function (p, idx) {
            var isParameter = idx >= paramStartIndex;
            var isEdmType = p.type.startsWith('Edm.');
            var result = isParameter && !isEdmType;
            return result;
        });
        if (!param) {
            return data;
        }
        var edmType = utilities_1.Utilities.getEdmTypeFromTypeName(this.metadata, param.type);
        if (!edmType) {
            return data;
        }
        var structuralType = utilities_1.Utilities.adaptStructuralType(mappingContext.metadataStore, edmType);
        if (structuralType instanceof breeze_client_1.EntityType) {
            data = structuralType.createEntity(data);
            return helper.unwrapInstance(data, null);
        }
        else if (structuralType instanceof breeze_client_1.ComplexType) {
            data = structuralType.createInstance(data);
            return helper.unwrapInstance(data, null);
        }
        return data;
    };
    OData4DataService.prototype.areValidPropertyNames = function (metadataStore, data) {
        var props = Object.keys(data);
        var result = props.every(function (p) {
            var sp = metadataStore.namingConvention.clientPropertyNameToServer(p);
            var cp = metadataStore.namingConvention.serverPropertyNameToClient(sp);
            return p === cp;
        });
        return result;
    };
    OData4DataService.prototype.getInvokableConfig = function (url) {
        if (!url) {
            return null;
        }
        var urlParts = url.split('/');
        var invokableName = urlParts.pop().replace(/\([^\)]*\)/, '');
        var actionConfig = ts_odatajs_1.oData.utils.lookupAction(invokableName, this.metadata);
        var functionConfig = ts_odatajs_1.oData.utils.lookupFunction(invokableName, this.metadata);
        return actionConfig || functionConfig;
    };
    OData4DataService.prototype.getUrl = function (mappingContext) {
        var url = this.getAbsoluteUrl(mappingContext.dataService, mappingContext.getUrl());
        return url;
    };
    OData4DataService.prototype.addQueryString = function (url, parameters) {
        var queryString = this.toQueryString(parameters);
        if (!queryString) {
            return url;
        }
        var sep = url.indexOf('?') < 0 ? '?' : '&';
        url += sep + queryString;
        return url;
    };
    OData4DataService.prototype.transformValue = function (prop, val) {
        if (prop.isUnmapped) {
            return undefined;
        }
        if (prop.dataType.quoteJsonOData) {
            val = val != null ? val.toString() : val;
        }
        return val;
    };
    OData4DataService.prototype.updateDeleteMergeRequest = function (request, aspect, routePrefix) {
        if (!aspect.extraMetadata) {
            aspect.extraMetadata = {};
        }
        var extraMetadata = aspect.extraMetadata;
        if (extraMetadata['etag']) {
            request.headers['If-Match'] = extraMetadata['etag'];
        }
        if (!extraMetadata['uriKey']) {
            extraMetadata['uriKey'] = this.getUriKey(aspect);
        }
        var uriKey = extraMetadata['uriKey'];
        request.requestUri =
            uriKey.indexOf('//') > 0 ? uriKey : routePrefix + uriKey;
    };
    OData4DataService.prototype.getUriKey = function (aspect) {
        var _this = this;
        var entityType = aspect.entity.entityType;
        var resourceName = entityType.defaultResourceName;
        var kps = entityType.keyProperties;
        var uriKeyValue = kps.length === 1
            ? this.fmtProperty(kps[0], aspect)
            : kps.map(function (kp) {
                return "".concat(kp.nameOnServer, "=").concat(_this.fmtProperty(kp, aspect));
            });
        var uriKey = "".concat(resourceName, "(").concat(uriKeyValue, ")");
        return uriKey;
    };
    OData4DataService.prototype.fmtProperty = function (prop, aspect) {
        return prop.dataType.fmtOData(aspect.getPropertyValue(prop.name));
    };
    OData4DataService.prototype.createError = function (error, url) {
        var result = new odata_error_1.ODataError();
        var response = error && error.response;
        result.message = error.message || error;
        result.statusText = error.message || error;
        if (!response) {
            return result;
        }
        if (response.statusCode !== '200') {
            result.message = response.statusText;
            result.statusText = response.statusText;
            result.status = Number(response.statusCode);
        }
        if (url) {
            result.url = url;
        }
        result.body = response.body;
        if (response.body) {
            var nextErr = void 0;
            try {
                var body = JSON.parse(response.body);
                result.body = body;
                if (body['odata.error']) {
                    body = body['odata.error'];
                }
                var msg = '';
                do {
                    nextErr = body.error || body.innererror;
                    if (!nextErr) {
                        msg = msg + this.getMessage(body);
                    }
                    nextErr = nextErr || body.internalexception;
                    body = nextErr || body;
                } while (nextErr);
                if (msg.length > 0) {
                    result.message = msg;
                }
            }
            catch (e) { }
        }
        this._catchNoConnectionError(result);
        return result;
    };
    OData4DataService.prototype.getMessage = function (body) {
        var messageKey = Object.keys(body)
            .find(function (k) { return k.toLowerCase() === 'message'; });
        if (!messageKey) {
            return '';
        }
        var msg = body[messageKey];
        return "".concat((typeof msg === 'string' ? msg : msg.value), "; ");
    };
    OData4DataService.prototype.toQueryString = function (payload) {
        var keys = Object.keys(payload);
        if (!keys.length) {
            return null;
        }
        var result = keys
            .map(function (key) {
            return "".concat(encodeURIComponent(key), "=").concat(encodeURIComponent(payload[key]));
        })
            .join('&');
        return result;
    };
    OData4DataService.BreezeAdapterName = 'OData4';
    return OData4DataService;
}(ProxyDataService));
exports.OData4DataService = OData4DataService;
//# sourceMappingURL=breeze-odata4-dataService.js.map