"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BreezeOData4 = void 0;
var breeze_client_1 = require("breeze-client");
var metadataAdapters = __importStar(require("./adapters"));
var breeze_odata4_dataService_1 = require("./breeze-odata4-dataService");
var breeze_odata4_options_1 = require("./breeze-odata4-options");
var breeze_odata4_uriBuilder_1 = require("./breeze-odata4-uriBuilder");
var class_registry_1 = require("./class-registry");
var datatypeSetups = __importStar(require("./datatypes/setups"));
var annotationDecorators = __importStar(require("./decorators"));
var BreezeOData4 = (function () {
    function BreezeOData4() {
    }
    BreezeOData4.configure = function (options) {
        var opts = __assign(__assign({}, breeze_odata4_options_1.DefaultOptions), (options || {}));
        if (!this.isConfigured) {
            breeze_odata4_uriBuilder_1.OData4UriBuilder.register();
            breeze_odata4_dataService_1.OData4DataService.register();
            metadataAdapters.NavigationAdapter.allowManyToMany = opts.allowManyToManyRelationships;
            metadataAdapters.NavigationAdapter.foreignKeyConventions = __spreadArray(__spreadArray([], opts.foreignKeyConventions, true), metadataAdapters.NavigationAdapter.foreignKeyConventions, true);
            metadataAdapters.NavigationAdapter.inferPartner = opts.inferNavigationPropertyPartner;
            metadataAdapters.NavigationAdapter.inferConstraints = opts.inferReferentialConstraints;
            BreezeOData4.registerClasses(opts);
            BreezeOData4.setupDataTypes();
            this.isConfigured = true;
        }
        if (opts.initializeAdapters) {
            breeze_client_1.config.initializeAdapterInstance('uriBuilder', breeze_odata4_uriBuilder_1.OData4UriBuilder.BreezeAdapterName, true);
            breeze_client_1.config.initializeAdapterInstance('dataService', breeze_odata4_dataService_1.OData4DataService.BreezeAdapterName, true);
        }
    };
    BreezeOData4.reset = function () {
        this.isConfigured = false;
    };
    BreezeOData4.registerClasses = function (options) {
        var _a, _b, _c;
        (_a = class_registry_1.ClassRegistry.AnnotationDecorators).add.apply(_a, __spreadArray(__spreadArray([], Object.values(annotationDecorators), false), options.annotationDecorators, false));
        (_b = class_registry_1.ClassRegistry.DataTypeSetups).add.apply(_b, __spreadArray(__spreadArray([], Object.values(datatypeSetups), false), options.dataTypeSetups, false));
        (_c = class_registry_1.ClassRegistry.MetadataAdapters).add.apply(_c, __spreadArray(__spreadArray([], Object.values(metadataAdapters), false), options.metadataAdapters, false));
    };
    BreezeOData4.setupDataTypes = function () {
        var dataTypeSetups = class_registry_1.ClassRegistry.DataTypeSetups.get();
        dataTypeSetups.forEach(function (s) { return s && s.register(); });
    };
    BreezeOData4.isConfigured = false;
    return BreezeOData4;
}());
exports.BreezeOData4 = BreezeOData4;
//# sourceMappingURL=breeze-odata4.js.map