"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.DateDataTypeSetup = void 0;
var breeze_client_1 = require("breeze-client");
var base_datatype_setup_1 = require("./base-datatype-setup");
var DateRegex = /(-\d)?\d{4}-\d{2}-\d{2}/;
var DateDataTypeSetup = (function (_super) {
    __extends(DateDataTypeSetup, _super);
    function DateDataTypeSetup() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = 'Date';
        _this.parseValue = function (val) {
            if (!val) {
                return null;
            }
            var result = val;
            if (typeof val === 'string') {
                var matchResult = DateRegex.exec(val);
                if (matchResult) {
                    return matchResult[0];
                }
            }
            var dateVal = val instanceof Date ? val : new Date("".concat(val, " "));
            if (isNaN(dateVal)) {
                _this.handleInvalidValue(val);
            }
            result = dateVal.toISOString().split('T')[0];
            return result;
        };
        _this.addSymbol = function () {
            var result = new breeze_client_1.DataType({
                defaultValue: '0000-01-01',
                name: _this.name,
                isDate: true,
                fmtOData: _this.parseValue,
                parseRawValue: _this.parseValue
            });
            breeze_client_1.DataType[_this.name] = result;
            return result;
        };
        return _this;
    }
    return DateDataTypeSetup;
}(base_datatype_setup_1.BaseDataTypeSetup));
exports.DateDataTypeSetup = DateDataTypeSetup;
//# sourceMappingURL=date-datatype-setup.js.map