"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomDecorator = void 0;
var breeze_client_1 = require("breeze-client");
var utilities_1 = require("../utilities");
var CustomTerm = 'Custom';
var CustomDecorator = (function () {
    function CustomDecorator() {
    }
    CustomDecorator.prototype.canDecorate = function (annotation) {
        return /.\.Custom\./.test(annotation.term);
    };
    CustomDecorator.prototype.decorate = function (expression, annotation) {
        var keys = Object.keys(annotation);
        breeze_client_1.core.arrayRemoveItem(keys, 'term', false);
        var valueKey = keys[0];
        var value = annotation[valueKey];
        var termParts = annotation.term.split('.');
        var startIndex = termParts.indexOf(CustomTerm);
        var customPath = termParts.slice(startIndex + 1);
        if (!customPath.length) {
            return;
        }
        var dataType = utilities_1.Utilities.getDataType(valueKey);
        var customValue = utilities_1.Utilities.parseValue(dataType, value);
        expression.custom = expression.custom instanceof Object ? expression.custom : {};
        customPath.reduce(function (prev, curr, index, arr) {
            if (index < arr.length - 1) {
                prev[curr] = prev[curr] instanceof Object ? prev[curr] : {};
                return prev[curr];
            }
            else {
                prev[curr] = customValue;
                return prev;
            }
        }, expression.custom);
    };
    return CustomDecorator;
}());
exports.CustomDecorator = CustomDecorator;
//# sourceMappingURL=custom-decorator.js.map