"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DescriptionDecorator = void 0;
var DescriptionDecorator = (function () {
    function DescriptionDecorator() {
        this.terms = ['Org.OData.Display.V1.Description', 'Org.OData.Core.V1.Description'];
    }
    DescriptionDecorator.prototype.canDecorate = function (annotation) {
        return this.terms.includes(annotation.term);
    };
    DescriptionDecorator.prototype.decorate = function (expression, annotation) {
        var value = annotation.string;
        expression.description = typeof value === 'string' ? value : value.text;
    };
    return DescriptionDecorator;
}());
exports.DescriptionDecorator = DescriptionDecorator;
//# sourceMappingURL=description-decorator.js.map