"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PublicationDecorator = void 0;
var breeze_client_1 = require("breeze-client");
var utilities_1 = require("../utilities");
var PublicationTerm = 'Org.OData.Publication.V1.';
var PublicationDecorator = (function () {
    function PublicationDecorator() {
    }
    PublicationDecorator.prototype.canDecorate = function (annotation) {
        return annotation.term.startsWith(PublicationTerm);
    };
    PublicationDecorator.prototype.decorate = function (expression, annotation) {
        var keys = Object.keys(annotation);
        breeze_client_1.core.arrayRemoveItem(keys, 'term', false);
        var valueKey = keys[0];
        var value = annotation[valueKey];
        var propName = annotation.term.replace(PublicationTerm, '');
        if (propName === '') {
            return;
        }
        var dataType = utilities_1.Utilities.getDataType(valueKey);
        var parsedValue = utilities_1.Utilities.parseValue(dataType, value);
        expression.publication = expression.publication instanceof Object ? expression.publication : {};
        expression.publication[propName] = parsedValue;
    };
    return PublicationDecorator;
}());
exports.PublicationDecorator = PublicationDecorator;
//# sourceMappingURL=publication-decorator.js.map