"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValidatorDecorator = void 0;
var breeze_client_1 = require("breeze-client");
var utilities_1 = require("../utilities");
var ValidatorTerm = 'Validator';
var ValidatorDecorator = (function () {
    function ValidatorDecorator() {
    }
    ValidatorDecorator.prototype.canDecorate = function (annotation) {
        return annotation.term.indexOf(".".concat(ValidatorTerm)) > -1;
    };
    ValidatorDecorator.prototype.decorate = function (expression, annotation) {
        expression.validators = expression.validators || [];
        var keys = Object.keys(annotation);
        breeze_client_1.core.arrayRemoveItem(keys, 'term', false);
        var valueKey = keys[0];
        var value = annotation[valueKey];
        var nameAndProp = annotation.term.replace(/^.*Validator\.?/, '').split('.');
        var name = nameAndProp.shift();
        var prop = nameAndProp.shift();
        if (!name) {
            return;
        }
        var validator = expression.validators.find(function (val) {
            return val.name === name;
        });
        if (!validator) {
            validator = { name: name };
            expression.validators.push(validator);
        }
        if (!prop) {
            return;
        }
        var dataType = utilities_1.Utilities.getDataType(valueKey);
        validator[prop] = utilities_1.Utilities.parseValue(dataType, value);
    };
    return ValidatorDecorator;
}());
exports.ValidatorDecorator = ValidatorDecorator;
//# sourceMappingURL=validator-decorator.js.map