"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AssociationEndpoint = void 0;
var ts_odatajs_1 = require("ts-odatajs");
var AssociationEndpoint = (function () {
    function AssociationEndpoint(init) {
        this.ConstrainMany = '*';
        this.ConstrainOne = '1';
        this.referentialConstraint = [];
        Object.assign(this, init);
    }
    Object.defineProperty(AssociationEndpoint.prototype, "containingEntityShortName", {
        get: function () {
            var result = this.containingEntityType.split('.').pop();
            return result;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AssociationEndpoint.prototype, "isCollection", {
        get: function () {
            var result = !!this.navigationProperty
                && ts_odatajs_1.oData.utils.isCollectionType(this.navigationProperty.type);
            return result;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AssociationEndpoint.prototype, "isMapped", {
        get: function () {
            var result = !!this.navigationProperty;
            return result;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AssociationEndpoint.prototype, "multiplicity", {
        get: function () {
            var result = this.isCollection ? this.ConstrainMany : this.ConstrainOne;
            return result;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AssociationEndpoint.prototype, "order", {
        get: function () {
            var result = Number(!this.isMapped) * 2 + Number(this.isCollection);
            return result;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AssociationEndpoint.prototype, "partnerEntityShortName", {
        get: function () {
            var result = this.partnerEntityType.split('.').pop();
            return result;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AssociationEndpoint.prototype, "propertyName", {
        get: function () {
            var result = this.isMapped ? this.navigationProperty.name : this._propertyName;
            return result;
        },
        set: function (value) {
            this._propertyName = value;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AssociationEndpoint.prototype, "role", {
        get: function () {
            var result = "".concat(this.containingEntityShortName, "_").concat(this.propertyName);
            return result;
        },
        enumerable: false,
        configurable: true
    });
    return AssociationEndpoint;
}());
exports.AssociationEndpoint = AssociationEndpoint;
//# sourceMappingURL=association-endpoint.js.map