"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AssociationSet = void 0;
var AssociationSet = (function () {
    function AssociationSet(namespace, endpoint, partnerEndpoint) {
        this.namespace = namespace;
        this.endpoints = [endpoint, partnerEndpoint];
    }
    Object.defineProperty(AssociationSet.prototype, "associationName", {
        get: function () {
            var result = "".concat(this.namespace, ".").concat(this.name);
            return result;
        },
        enumerable: false,
        configurable: true
    });
    AssociationSet.prototype.containsProperty = function (navigationProperty) {
        var result = !!navigationProperty
            && this.endpoints.some(function (e) { return e.navigationProperty === navigationProperty; });
        return result;
    };
    Object.defineProperty(AssociationSet.prototype, "endpoints", {
        get: function () {
            return this._endpoints;
        },
        set: function (value) {
            this._endpoints = value.sort(function (a, b) { return a.order - b.order; });
        },
        enumerable: false,
        configurable: true
    });
    AssociationSet.prototype.getPartnerEndpoint = function (endpoint) {
        var result = endpoint && this.endpoints.find(function (e) { return e !== endpoint; });
        return result;
    };
    Object.defineProperty(AssociationSet.prototype, "fullyMapped", {
        get: function () {
            var result = this.endpoints.every(function (e) { return e.isMapped; });
            return result;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AssociationSet.prototype, "name", {
        get: function () {
            var result = this.endpoints
                .map(function (e) { return e.role; })
                .join('_');
            return result;
        },
        enumerable: false,
        configurable: true
    });
    return AssociationSet;
}());
exports.AssociationSet = AssociationSet;
//# sourceMappingURL=association-set.js.map