"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.EdmEnum = exports.EdmEnumMember = void 0;
var breeze_client_1 = require("breeze-client");
var EdmEnumMember = (function (_super) {
    __extends(EdmEnumMember, _super);
    function EdmEnumMember() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return EdmEnumMember;
}(breeze_client_1.BreezeEnum));
exports.EdmEnumMember = EdmEnumMember;
var EdmEnum = (function (_super) {
    __extends(EdmEnum, _super);
    function EdmEnum(options) {
        var _this = _super.call(this, options) || this;
        _this.validatorCtor = breeze_client_1.Validator.none;
        _this.members = [];
        _this.parse = function (val, sourceTypeName) {
            if (typeof val === 'undefined' || val === null) {
                return null;
            }
            if (sourceTypeName === 'object' && val.parentEnum === _this) {
                return val;
            }
            if (sourceTypeName === 'string') {
                return _this.fromName(val);
            }
            if (sourceTypeName === 'number') {
                return _this.fromValue(val);
            }
            return null;
        };
        _this.parseRawValue = function (val) {
            return _this.parse(val, 'string');
        };
        return _this;
    }
    EdmEnum.prototype.addSymbol = function (enumMember) {
        var _a;
        (_a = enumMember.displayName) !== null && _a !== void 0 ? _a : (enumMember.displayName = enumMember.name);
        enumMember.value = this.underlyingDataType.parse(enumMember.rawValue, 'string');
        var result = this.createEdmEnumMember(enumMember);
        this.members.push(result);
        if (!this.defaultValue) {
            this.defaultValue = result;
        }
        this[enumMember.name] = result;
        return result;
    };
    EdmEnum.prototype.fromValue = function (value) {
        var result = this.isFlags && value
            ? this.fromFlagsEnumValue(value)
            : this.members.find(function (m) { return m.value === value; });
        return result;
    };
    EdmEnum.prototype.fromName = function (name) {
        var value = Number(name);
        if (!isNaN(value)) {
            return this.fromValue(value);
        }
        var result = this.isFlags && name.includes(',')
            ? this.fromFlagsEnumName(name)
            : EdmEnum.fromName.bind(this)(name);
        return result;
    };
    EdmEnum.prototype.getSymbols = function () {
        return this.members;
    };
    EdmEnum.prototype.fromFlagsEnumValue = function (value) {
        var result = this.createEdmEnumMember();
        var flags = this.members
            .filter(function (m) { return m.value > 0 && (m.value | value) === value; });
        if (!flags.length) {
            return undefined;
        }
        result.displayName = flags.map(function (f) { return f.displayName; }).join(', ');
        result.name = flags.map(function (f) { return f.name; }).join(',');
        result.value = flags.reduce(function (tot, cur) { return tot + cur.value; }, 0);
        return result;
    };
    EdmEnum.prototype.fromFlagsEnumName = function (name) {
        var _this = this;
        var result;
        name.split(',')
            .filter(function (n) { return _this.members.some(function (m) { return m.name === n; }); })
            .forEach(function (memberName) {
            var symbol = _this.fromName(memberName.trim());
            if (!result) {
                result = Object.assign(_this.createEdmEnumMember(), symbol);
                result.name = name;
            }
            else {
                result.displayName += ", ".concat(symbol.displayName);
                result.value += symbol.value;
            }
        }, 0);
        return result;
    };
    EdmEnum.prototype.createEdmEnumMember = function (enumMember) {
        var result = new EdmEnumMember(enumMember);
        result._$typeName = this.name;
        result.parentEnum = this;
        return result;
    };
    return EdmEnum;
}(breeze_client_1.BreezeEnum));
exports.EdmEnum = EdmEnum;
//# sourceMappingURL=edm-enum.js.map