import { Edm, EdmExtra, Edmx } from 'ts-odatajs';
import { AssociationEndpoint, AssociationSet } from '../models';
import { MetadataAdapter } from './metadata-adapter';
export declare const EntityNotFound = "Could not find entity with type name";
export declare class NavigationAdapter implements MetadataAdapter {
    static allowManyToMany: boolean;
    static inferConstraints: boolean;
    static inferPartner: boolean;
    static foreignKeyConventions: ((endpoint: AssociationEndpoint, suffix: string) => string)[];
    private metadata;
    private entityContainer;
    private associations;
    adapt(metadata: Edmx.DataServices): void;
    adaptSchema(schema: Edm.Schema): void;
    private adaptEntityType;
    private adaptNavigationProperty;
    private getUnderlyingEntityType;
    private trySetReferentialConstraint;
    private getAllTypes;
    private getKeys;
    private getNavigationProperties;
    private getProperties;
    private tryGetPartnerNavigationProperty;
    private validateRelationship;
    private getEntitySetNameByEntityType;
    private navigationPropertyTypeMatches;
    private setAssociationSet;
    private setAssociations;
    private getAssociationEndpoint;
    processAssociation(association: AssociationSet): EdmExtra.Association;
    private getReferentialConstraint;
}
