import { DataService, DataServiceAdapter, Entity, JsonResultsAdapter, MappingContext, MetadataStore, QueryResult, SaveBundle, SaveContext, SaveResult, ServerError } from 'breeze-client';
import { ChangeRequestInterceptorCtor } from 'breeze-client/src/interface-registry';
import { Edmx } from 'ts-odatajs';
import { ODataHttpClient } from './odata-http-client';
export interface DataServiceSaveContext extends SaveContext {
    tempKeys: any[];
    contentKeys: any[];
}
export declare class ProxyDataService {
}
export declare class OData4DataService extends ProxyDataService implements DataServiceAdapter {
    static BreezeAdapterName: string;
    private innerAdapter;
    private actions;
    name: string;
    headers: {
        [name: string]: string;
    };
    metadataAcceptHeader: string;
    metadata: Edmx.Edmx;
    httpClient: ODataHttpClient;
    jsonResultsAdapter: JsonResultsAdapter;
    static register(): void;
    constructor();
    get changeRequestInterceptor(): ChangeRequestInterceptorCtor;
    _catchNoConnectionError(err: ServerError): any;
    _createChangeRequestInterceptor(saveContext: SaveContext, saveBundle: SaveBundle): {
        getRequest: <T>(request: T, entity: Entity, index: number) => T;
        done: (requests: any[]) => void;
    };
    checkForRecomposition(interfaceInitializedArgs: {
        interfaceName: string;
        isDefault: boolean;
    }): void;
    _prepareSaveBundle(saveContext: SaveContext, saveBundle: SaveBundle): SaveBundle;
    _prepareSaveResult(saveContext: SaveContext, saveResult: SaveResult): SaveResult;
    initialize(): void;
    getAbsoluteUrl(dataService: DataService, url: string): string;
    fetchMetadata(metadataStore: MetadataStore, dataService: DataService): Promise<Edmx.DataServices>;
    executeQuery(mappingContext: MappingContext): Promise<QueryResult>;
    saveChanges(saveContext: DataServiceSaveContext, saveBundle: SaveBundle): Promise<SaveResult>;
    private createChangeRequests;
    private getRequest;
    private getData;
    private areValidPropertyNames;
    private getInvokableConfig;
    private getUrl;
    private addQueryString;
    private transformValue;
    private updateDeleteMergeRequest;
    private getUriKey;
    private fmtProperty;
    private createError;
    private getMessage;
    private toQueryString;
}
