import { MetadataAdapter } from './adapters/metadata-adapter';
import { DataTypeSetup } from './datatypes/setups/datatype-setup';
import { AnnotationDecorator } from './decorators/annotation-decorator';
export declare type Type<T> = new () => T;
export declare class ClassRepository<T> {
    types: Type<T>[];
    add(...types: Type<T>[]): void;
    get(): T[];
}
export declare class ClassRegistry {
    static AnnotationDecorators: ClassRepository<AnnotationDecorator>;
    static DataTypeSetups: ClassRepository<DataTypeSetup>;
    static MetadataAdapters: ClassRepository<MetadataAdapter>;
}
