import { Edm } from 'ts-odatajs';
import { AnnotationDecorator } from './annotation-decorator';
export interface Publication {
    attributionUrl?: string;
    documentationUrl?: string;
    imageUrl?: string;
    keywords?: string[];
    lastModified?: string;
    privacyPolicyUrl?: string;
    publisherId?: string;
    publisherName?: string;
    termsOfUseUrl?: string;
}
export interface ExpressionWithPublication extends Edm.Base.Annotatable {
    publication?: {
        [key: string]: any;
    };
}
export declare class PublicationDecorator implements AnnotationDecorator {
    canDecorate(annotation: Edm.Annotation): boolean;
    decorate(expression: ExpressionWithPublication, annotation: Edm.Annotation): void;
}
