import { BreezeEnum, DataType, Validator } from 'breeze-client';
export declare class EdmEnumMember extends BreezeEnum {
    parentEnum: BreezeEnum;
    displayName: string;
    name: string;
    rawValue: string;
    value: number;
}
export interface EdmEnumOptions {
    isFlags: boolean;
    name: string;
    underlyingDataType: DataType;
}
export declare class EdmEnum extends BreezeEnum {
    readonly isFlags: boolean;
    readonly name: string;
    validatorCtor: () => Validator;
    private readonly underlyingDataType;
    private defaultValue;
    private members;
    constructor(options: EdmEnumOptions);
    addSymbol(enumMember?: Partial<EdmEnumMember>): BreezeEnum;
    fromValue(value: number): EdmEnumMember;
    fromName(name: string): EdmEnumMember;
    getSymbols(): EdmEnumMember[];
    parse: (val: any, sourceTypeName?: string) => any;
    parseRawValue: (val: any) => any;
    private fromFlagsEnumValue;
    private fromFlagsEnumName;
    private createEdmEnumMember;
}
