import { ComplexType, DataType, EntityType, StructuralType, MetadataStore } from 'breeze-client';
import { Edm, Edmx } from 'ts-odatajs';
export interface InvokableEntry {
    config: Edm.Action | Edm.Function;
    namespace: string;
    url?: string;
}
export declare namespace Utilities {
    const dataTypeMap: {
        [key: string]: DataType;
    };
    function adaptMetadata(metadata: Edmx.Edmx): Edmx.Edmx;
    function getDataType(key: string): DataType;
    function getEdmTypeFromTypeName(metadata: Edmx.Edmx, typeName: string): Edm.ComplexType | Edm.EntityType;
    function adaptComplexType(metadataStore: MetadataStore, complexType: Edm.ComplexType): ComplexType;
    function adaptEntityType(metadataStore: MetadataStore, entityType: Edm.EntityType): EntityType;
    function adaptStructuralType(metadataStore: MetadataStore, structuralType: Edm.ComplexType | Edm.EntityType): StructuralType;
    function getActions(metadata: Edmx.Edmx, metadataStore: MetadataStore): InvokableEntry[];
    function getFunctions(metadata: Edmx.Edmx, metadataStore: MetadataStore): InvokableEntry[];
    function getInvokableEntries(metadata: Edmx.Edmx, metadataStore: MetadataStore, accessor: (schema: Edm.Schema) => Edm.Action[] | Edm.Function[]): InvokableEntry[];
    function getInvokableUrl(metadata: Edmx.Edmx, metadataStore: MetadataStore, config: Edm.Action | Edm.Function, namespace: string): string;
    function parseValue(dataType: DataType, value: any): any;
}
